/*
Copyright (C) 2001 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#if !defined(AFX_GFXCONTEXT_H__B59609D3_D6F8_4C85_AF86_EE3E0ADE39B7__INCLUDED_)
#define AFX_GFXCONTEXT_H__B59609D3_D6F8_4C85_AF86_EE3E0ADE39B7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Utility\CritSect.h"
#include "Utility\Unique.h"

// This class basically provides an extra level of security for our
// multithreaded code. Threads can Grab the CGraphicsContext to prevent
// other threads from changing/releasing any of the pointers while it is
// running.

// It is based on CCritSect for Lock() and Unlock()
class CGraphicsContext : public CCritSect, public CUnique< CGraphicsContext >
{
public:
	//CGraphicsContext();
	virtual ~CGraphicsContext() {}

	virtual HRESULT Initialise(HWND hWnd, HWND hWndStatus, DWORD dwWidth, DWORD dwHeight, BOOL bWindowed ) = 0;

	virtual LPDIRECT3DDEVICE8 GetD3DDev() = 0;

	virtual D3DCAPS8 GetCaps() const = 0;

	virtual BOOL Ready() = 0;
	virtual void SetReady(BOOL bReady) = 0;
	virtual void Cleanup3DEnvironment() = 0;

	virtual void Clear(DWORD dwFlags) = 0;
	virtual HRESULT UpdateFrame() = 0;

	virtual HRESULT GetBufferSize(DWORD * pdwWidth, DWORD * pdwHeight) = 0;

	virtual LRESULT OnSize(WPARAM wParam) = 0;
	virtual LRESULT OnExitSizeMove() = 0;
	virtual void OnChangeDevice() = 0;
	
	virtual void ToggleFullscreen() = 0;

	virtual void DumpScreenShot() = 0;


};

#endif // !defined(AFX_GFXCONTEXT_H__B59609D3_D6F8_4C85_AF86_EE3E0ADE39B7__INCLUDED_)
